<template>
    <div>
        <div class="flex items-center uppercase tracking-wide text-c2 p-2" :class="{'hover:bg-gray-200 cursor-pointer': !isActive}" @click="expand = !expand">
            <div class="rounded-full w-3 h-3 mr-2" :style="{'background-color': color}"></div>
            <p>
                {{  name }}
            </p>
            <div class="ml-auto" v-if="!isActive">
                <fa :icon="isExpanded ? 'chevron-up' : 'chevron-down'" />
            </div>
            <div>
                <custom-button accent css-class="px-1 py-0 ml-2" v-if="!userFavorite" icon="heart" @click="favorize()" />
                <custom-button negative css-class="px-1 py-0 ml-2" v-if="userFavorite" icon="heart-broken" @click="unFavorize()" />
            </div>
        </div>
        <div v-if="isExpanded">
            <div 
                class="border-b-0"
                v-for="(unit, unitKey) in filteredCostunits"
                :key="unitKey"
            >
                <div
                    class="flex cursor-pointer border-l-8 border-transparent pr-4 pl-2 py-2 text-lg text-grey-darkest hover:border-purple-600 hover:bg-gray-200 items-center"
                    :style="{'border-left-color': $store.getters['timeline/isCostunitActive'](unit) ? color : null}"
                    @click="$emit('selectCostunit', unit)"
                >
                    <div class="pl-2" v-html="unit.name"></div>
                    <div class="ml-auto pl-2 text-gray-700">
                        <fa icon="clock" class="text-black rounded-full pulse pulse--small" v-if="$store.getters['timeline/isCostunitActive'](unit)" :class="{'mr-3': !unit.is_billable || !unit.is_message_required}" />
                        <fa :icon="['fab', 'creative-commons-nc']" v-if="!unit.is_billable" />
                        <fa icon="comment-slash" v-if="!unit.is_message_required" />
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import CustomButton from '~/components/CustomButton'

export default {
    name: 'Customer',
    components: {
        CustomButton
    },
    props: {
        userFavorite: [Object, String],
        id: {
            type: [Number, String],
            required: true,
        },
        name: {
            type: String,
            required: true
        },
        color: {
            type: String,
            default: '#000'
        },
        costunits: {
            type: Array,
            required: true
        },
        filterQuery: {
            type: String,
            default: ''
        }
    },
    methods: {
        favorize() {
            this.$axios.post('/user-favorite-customer', {customer_id:this.id}).then(response => {
                this.$store.dispatch('customer/load');
            });
        },
        unFavorize() {
            this.$axios.delete('/user-favorite-customer/' + this.userFavorite.id).then(response => {
                this.$store.dispatch('customer/load');
            });
        }
    },
    computed: {
        filteredCostunits() {
            if (this.filterQuery === '' || this.name.toLowerCase().includes(this.filterQuery.toLowerCase())) {
                return this.costunits
            }

            return this.costunits.filter(costunit => {
                return this.$store.getters['timeline/isCostunitActive'](costunit) || costunit.name.toLowerCase().includes(this.filterQuery.toLowerCase())
            })
        },
        isActive() {
            return this.costunits.some(costunit => {
                return this.$store.getters['timeline/isCostunitActive'](costunit)
            })
        },
        isExpanded() {
            return !!this.filterQuery.trim() || this.expand || this.isActive
        }
    },
    data() {
        return {
            expand: false
        }
    }
}
</script>
